
body.article{
  background: var(--clr-back);
}

/* LAYOUTS
  ========================================================================== */

/* types of layouts */
body.article--media{
  display: grid;
  grid-template-columns: min(48rem, 50%) 1fr;
}
body.article--long{
  display: grid;
  grid-template-columns: min(24rem, 50%) 1fr;
}

body > section{
  /* inside of the grid should be put like that
  to ensure that the 1fr is not going to overflow */
  overflow: auto;
  max-width: 100%;
}

/* separate scroll on media and toc */ 
.full-h-sticky{
  position: sticky;
  top: 0;
  height: 100vh;
  overflow-y: auto;
}

body.article--long .article__aside{
  border-right: var(--border);
}

/* text itself has max size */
body.article--long .article__content{
  max-width: min(36rem, 100%);
  margin: 0 auto;
}

@media (max-width: 66rem) {

  body.article--media,
  body.article--long{
    /* back in one column */
    grid-template-columns: 1fr;
  }

  /* reset stickyness */
  .full-h-sticky{
    position: revert;
    height: revert;
  }

  body.article--long .article__aside{
    border-right: none;
    border-bottom: var(--border);
  }

}

  
/* GENERAL
  ========================================================================== */

.article__media{
  box-sizing: border-box;
}
.article__text > *:not(:last-child),
.article__aside > *:not(:last-child){
  border-bottom: var(--border);
}

footer.article__footer{
  color: var(--clr-fade);
}

.article__title{
  margin: calc(var(--lh) * 1) 0 0;
}

.article__toc a::after{
  content: none;
}

.article__media{
  background: var(--clr-back-dark);
  display: grid;
  grid-gap: var(--lh);
  grid-template-columns: repeat(auto-fit, minmax(250px, 1fr));
  grid-template-rows: min-content;
  grid-auto-rows: min-content;
  align-items: center;
}


/* HEADER STYLES
  ========================================================================== */

h1{
  font-size: var(--fs-h-plus);
}

.article__text h2{
  text-align: center;
  font-size: var(--fs-h-plus);
}
.article__text h3{
  font-size: var(--fs-h);
  text-decoration: var(--underline);
  counter-set: h4 0;
}
.article__text h4{
  text-decoration: var(--underline);
}

/* modification vertical rythm */
.article__text h2{
  margin-bottom: calc(var(--lh) * 2);
}
.article__text :is(h1,h2,h3,h4,h5,h6):first-child{
  margin-top: calc(var(--lh) * 2);
}
.article__text :is(p):last-child{
  margin-bottom: var(--lh);
}


/* ARTICLES COUNTERS
  ========================================================================== */

.article__content{
  counter-set: h2 0;
}
.article__content h2{
  counter-set: h3 0;
}
.article__content h2::before{
  counter-increment: h2;
  content: counter(h2) ". ";
}
.article__content h3{
  counter-set: h4 0;
}
.article__content h3::before{
  counter-increment: h3;
  content: counter(h2) "." counter(h3) ". ";
}
.article__content h4{
  counter-set: h5 0;
}
.article__content h4::before{
  counter-increment: h4;
  content: counter(h2) "." counter(h3) "." counter(h4) ". ";
}
.article__content h5{
  counter-set: h6 0;
}
.article__content h5::before{
  counter-increment: h5;
  content: counter(h2) "." counter(h3) "." counter(h4) ". " counter(h5) ". ";
}
.article__content h6::before{
  counter-increment: h6;
  content: counter(h2) "." counter(h3) "." counter(h4) ". " counter(h5) ". " counter(h6) ". ";
}


/* TOC */
.toc > ul{
  padding-left: 0;
}
.article__toc ul { 
  counter-reset: ulItem; list-style: none;
}
.article__toc ul > li:before { 
  content: counters(ulItem, ".") ". "; counter-increment: ulItem; 
}


/* IMG
   ========================================================================== */

figure > img{
  /* images can not be bigger than a smaller centered column than the main column */
  margin-left: auto;
  margin-right: auto;
  max-width: calc(100% - calc(4 * var(--lh)));
}
figure.figure-full > img{
  /* full images take all column */
  max-width: 100%;
}

figure > figcaption{
  /* captions are smaller than main text */
  margin-left: calc(4 * var(--lh));
  margin-right: calc(4 * var(--lh));
}

@media (max-width: 36rem) {

  figure > img{
    /* all images take full width on small devices */
    max-width: 100vw !important;
    margin-left: calc(var(--lh) * -1);
    margin-right: calc(var(--lh) * -1);
  }

  figure > figcaption{
    /* captions have same width than main text */
    margin-left: 0;
    margin-right: 0;
  }

}

/* PRINT
   ========================================================================== */

@media print{

  body.article--long{
    display: grid;
    grid-template-columns: 1fr;
  }

  body.article--long .article__aside{
    border: none;
    position: initial;
    height: auto;
    grid-row: 1;
  }

  body.article--long .article__text{
    max-width: 100%;
  }

  img{
    outline: var(--border);
    max-width: 600px;
  }

}